SystemOrganization addCategory: #'Pier-Documentation'!

ReadWriteStream subclass: #PRLatexStream
	instanceVariableNames: ''
	classVariableNames: 'LatexCharacters'
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexStream class methodsFor: 'initialization' stamp: 'lr 2/9/2006 13:34'!
initialize
	LatexCharacters := Dictionary new.
	LatexCharacters
		at: $# put: '\#';
		at: $& put: '\&';
		at: $% put: '\%';
		at: $$ put: '\$';
		at: ${ put: '\{';
		at: $} put: '\}';
		at: $" put: '\symbol{34}';
		" -- "
		at: $[ put: '{[}';
		at: $] put: '{]}';
		at: $| put: '$|$';
		at: $< put: '$<$';
		at: $> put: '$>$';
		at: $/ put: '$/$';
		at: $\ put: '$\backslash$';
		at: $_ put: '$\leftarrow$';
		at: $^ put: '$\uparrow$';
		" -- "	
		at: $ put: '\"{a}';
		at: $ put: '\"{A}';
		at: $ put: '\"{e}';
		at: $ put: '\"{E}';
		at: $ put: '\"{i}';
		at: $ put: '\"{I}';
		at: $ put: '\"{o}';
		at: $ put: '\"{O}';
		at: $ put: '\"{u}';
		at: $ put: '\"{U}';
		at: $ put: '\"{y}';
		at: $ put: '\"{Y}';
		" -- "
		at: $ put: '\^{a}';
		at: $ put: '\^{A}';
		at: $ put: '\^{e}';
		at: $ put: '\^{E}';
		at: $ put: '\^{i}';
		at: $ put: '\^{I}';
		at: $ put: '\^{o}';
		at: $ put: '\^{O}';
		at: $ put: '\^{u}';
		at: $ put: '\^{U}';
		" -- " 
		at: $ put: '\`{a}';
		at: $ put: '\`{A}';
		at: $ put: '\`{e}';
		at: $ put: '\`{E}';
		at: $ put: '\`{i}';
		at: $ put: '\`{I}';
		at: $ put: '\`{o}';
		at: $ put: '\`{O}';
		at: $ put: '\`{u}';
		at: $ put: '\`{U}';	
		" -- " 
		at: $ put: '\''{a}';
		at: $ put: '\''{A}';
		at: $ put: '\''{e}';
		at: $ put: '\''{i}';
		at: $ put: '\''{I}';
		at: $ put: '\''{o}';
		at: $ put: '\''{O}';
		at: $ put: '\''{u}';
		at: $ put: '\''{U}';
		" -- "
		at: $ put: '\c{c}';
		at: $ put: '\c{C}';
		" -- "
		at: $~ put: '\~{}';
		at: $ put: '\~{n}';
		at: $ put: '\~{N}';
		" -- "
		yourself.! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 2/9/2006 01:56'!
basicPutAll: aString
	super nextPutAll: aString.! !

!PRLatexStream methodsFor: 'private' stamp: 'lr 2/9/2006 01:55'!
basicPut: aCharacter
	super nextPut: aCharacter.! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 2/9/2006 01:58'!
comment: anObject
	self basicPut: $%; space; basicPutAll: anObject asString; cr.! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 2/6/2006 15:20'!
cr
	(position isZero
		or: [ position > 1 
		and: [ (collection at: position) = Character cr
		and: [ (collection at: position - 1) = Character cr ] ] ])
			ifTrue: [ ^ self ].
	super cr.! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 2/9/2006 13:22'!
curly: anObject
	self basicPut: ${; print: anObject; basicPut: $}.! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 2/9/2006 13:22'!
environment: aString do: anObject
	self tag: 'begin'; curly: aString; cr.
	self print: anObject.
	self tag: 'end'; curly: aString; cr.! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 2/9/2006 01:59'!
nextPutAll: anObject
	anObject asString do: [ :each | self nextPut: each ].! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 2/9/2006 13:35'!
nextPut: aCharacter
	| string |
	string := LatexCharacters at: aCharacter ifAbsent: nil.
	string isNil
		ifTrue: [ self basicPut: aCharacter ]
		ifFalse: [ self basicPutAll: string ].! !

!PRLatexStream methodsFor: 'initialization' stamp: 'lr 2/9/2006 13:28'!
on: aCollection
	super on: aCollection.
	self 
		comment: SystemVersion current asString; 
		comment: TimeStamp now asString;
		cr;
		comment: 'This is an automatically generated file, do not modify manually!!';
		cr; 
		cr.! !

!PRLatexStream methodsFor: 'streaming' stamp: 'lr 2/9/2006 13:18'!
print: anObject
	anObject printLatexOn: self.! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 2/9/2006 13:22'!
square: anObject
	self basicPut: $[; print: anObject; basicPut: $].! !

!PRLatexStream methodsFor: 'conveniance' stamp: 'lr 2/9/2006 02:06'!
tag: aString
	self basicPut: $\; basicPutAll: aString.! !

!UndefinedObject methodsFor: '*pier-documentation-printing' stamp: 'lr 2/9/2006 13:21'!
printLatexOn: aStream! !

!BlockContext methodsFor: '*pier-documentation-printing' stamp: 'lr 2/9/2006 13:20'!
printLatexOn: aStream
	self numArgs = 0 
		ifTrue: [ self value ]
		ifFalse: [ self value: aStream ].! !

!Object methodsFor: '*pier-documentation-printing' stamp: 'lr 2/9/2006 13:18'!
printLatexOn: aStream
	aStream nextPutAll: self displayString.! !

Object subclass: #PRLatexBuilder
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 2/6/2006 12:59'!
build
	self build: self packages.! !

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 2/6/2006 12:58'!
build: aCollection
	self build: aCollection in: self directory.! !

!PRLatexBuilder class methodsFor: 'building' stamp: 'lr 2/9/2006 15:56'!
build: aCollection in: aDirectory
	aCollection do: [ :each |
		self new 
			setPackage: each;
			setDirectory: aDirectory;
			build ].! !

!PRLatexBuilder class methodsFor: 'accessing' stamp: 'lr 2/6/2006 12:55'!
directory
	^ FileDirectory default directoryNamed: 'docs'.! !

!PRLatexBuilder class methodsFor: 'accessing' stamp: 'lr 2/6/2006 12:51'!
packages
	^ #( 'Magritte-Model' 'Magritte-Seaside' 'Magritte-Morph' 'Pier-Model' 'Pier-Security' 'Pier-Seaside' 'Pier-OmniBrowser' )
		collect: [ :each | PackageInfo named: each ].! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/9/2006 16:01'!
build
	self 
		latex: [ :stream | self buildPackage: self package on: stream ]
		named: self package packageName.! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/10/2006 11:50'!
buildClassEnum: aCollection labelled: aString on: aStream
	aCollection isEmpty ifTrue: [ ^ self ].
	aStream tag: 'subsubsection'; curly: aString; cr.
	aCollection 
		do: [ :each | aStream print: each name ]
		separatedBy: [ aStream nextPutAll: ', ' ].
	aStream cr; cr.! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/9/2006 20:29'!
buildClass: aClass category: aString on: aStream
	(Categorizer allCategory = aString
		or: [ Categorizer nullCategory = aString ]
		or: [ aString beginsWith: 'private' ])
			ifTrue: [ ^ self ].
	((self package methodsInCategory: aString ofClass: aClass)
		allSatisfy: [ :each | (aClass firstPrecodeCommentFor: each methodSymbol) isEmptyOrNil ])
			ifTrue: [ ^ self ].
	aStream tag: 'subsubsection'; curly: aString; cr.
	aStream environment: 'itemize' do: [
		(self package methodsInCategory: aString ofClass: aClass) asSortedCollection
			do: [ :each | self buildClass: aClass category: aString selector: each methodSymbol on: aStream ] ].
	aStream cr; cr.! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/9/2006 16:21'!
buildClass: aClass category: aString selector: aSelector on: aStream
	| source |
	source := aClass firstPrecodeCommentFor: aSelector.
	source isEmptyOrNil ifTrue: [ ^ self ].
	aStream 
		tag: 'item'; curly: [ aStream tag: 'code'; curly: aClass name , '>>' , (aClass methodHeaderFor: aSelector) ];
		tag: 'index'; curly: aSelector.
	aStream basicPutAll: ' \\'; cr.
	self wiki: source offset: 6 on: aStream.! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/10/2006 11:51'!
buildClass: aClass on: aStream
	aStream 
		tag: 'subsubsection'; curly: [
			aStream
				tag: 'label'; curly: aClass name; 
				tag: 'index'; curly: aClass name;
				print: aClass name ];
		cr; cr.
	self 
		buildClassEnum: aClass allSuperclasses allButLast reverse 
		labelled: 'Superclasses' on: aStream. 
	self 
		buildClassEnum: ((aClass allSubclasses
			select: [ :each | self package includesClass: each ]) 
			asSortedCollection: [ :a :b | a name <= b name ])
		labelled: 'Subclasses' on: aStream.
	self wiki: aClass organization classComment offset: 5 on: aStream.
	aStream cr; cr.
	(self package coreCategoriesForClass: aClass) asSortedCollection 
		do: [ :each | self buildClass: aClass category: each on: aStream ].! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/10/2006 11:50'!
buildPackage: aPackage category: aSymbol on: aStream
	| filename |
	aStream 
		tag: 'subsection'; curly: [
			aStream
				tag: 'label'; curly: aSymbol; 
				tag: 'index'; curly: aSymbol;
				print: aSymbol ]; 
		cr.
	((self package classes
		select: [ :each | each category = aSymbol ])
		asSortedCollection: [ :a :b | a name <= b name ])
		do: [ :each |
			self 
				latex: [ :stream | self buildClass: each on: stream ]
				named: (filename := aPackage packageName , '-' , each name).
			aStream 
				tag: 'input'; 
				curly: [ aStream basicPutAll: self directory localName , '/' , filename ]; 
				cr ].
	aStream cr.! !

!PRLatexBuilder methodsFor: 'building' stamp: 'lr 2/10/2006 11:50'!
buildPackage: aPackage on: aStream
	aStream 
		tag: 'section'; curly: [
			aStream
				tag: 'label'; curly: aPackage packageName; 
				tag: 'index'; curly: aPackage packageName;
				print: aPackage packageName ]; 
		cr; cr.
	self package systemCategories 
		do: [ :each | self buildPackage: aPackage category: each on: aStream ].! !

!PRLatexBuilder methodsFor: 'private' stamp: 'lr 2/6/2006 16:10'!
class: aString
	self tag: 'href'; curly: aString; curly: aString.! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 2/6/2006 13:00'!
directory
	^ directory! !

!PRLatexBuilder methodsFor: 'private' stamp: 'lr 2/6/2006 15:31'!
latex: aBlock named: aFileName
	| latex stream |
	aBlock value: (latex := PRLatexStream on: String new).
	stream := self directory forceNewFileNamed: aFileName , '.tex'.
	[ stream nextPutAll: latex contents ] ensure: [ stream close ].! !

!PRLatexBuilder methodsFor: 'accessing' stamp: 'lr 2/6/2006 13:00'!
package
	^ package! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 2/6/2006 13:00'!
setDirectory: aDirectory
	directory := aDirectory! !

!PRLatexBuilder methodsFor: 'initialization' stamp: 'lr 2/6/2006 13:00'!
setPackage: aPackage
	package := aPackage! !

!PRLatexBuilder methodsFor: 'private' stamp: 'lr 2/6/2006 15:56'!
wiki: aString offset: anInteger on: aStream
	^ PRLatexWriter 
		format: (PRDocumentParser parse: (aString ifNil: [ String new ]))
		offset: anInteger on: aStream.! !

PRVisitor subclass: #PRLatexWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Documentation'!

!PRLatexWriter class methodsFor: 'instance creation' stamp: 'lr 2/6/2006 15:25'!
format: aDocument offset: anInteger on: aStream
	^ self new
		setOffset: anInteger;
		setStream: aStream;		
		visit: aDocument;
		contents.! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 2/6/2006 13:13'!
contents
	^ self stream contents.! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 2/6/2006 13:12'!
offset
	^ offset! !

!PRLatexWriter methodsFor: 'configuration' stamp: 'lr 2/6/2006 13:15'!
sectionForLevel: anInteger
	^ #( 'part' 'chapter' 'section' 'subsection' 'subsubsection' 'paragraph' )
			at: self offset + anInteger ifAbsent: 'subparagraph'.! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 2/6/2006 13:13'!
setOffset: anInteger
	offset := anInteger! !

!PRLatexWriter methodsFor: 'initialization' stamp: 'lr 2/6/2006 13:13'!
setStream: aStream
	stream := aStream! !

!PRLatexWriter methodsFor: 'accessing' stamp: 'lr 2/6/2006 13:12'!
stream
	^ stream! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2006 11:51'!
visitAnchor: anObject
	self stream tag: 'label'; curly: anObject name; cr.! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2006 12:05'!
visitExternalLink: anObject
	self stream
		tag: 'href'; 
		curly: [ self stream basicPutAll: anObject url ];
		curly: [ super visitExternalLink: anObject ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:21'!
visitHeader: anObject
	self stream tag: (self sectionForLevel: anObject level); curly: anObject text; cr.! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2006 12:18'!
visitInternalLink: anObject
	self stream 
		tag: 'hyperlink'; 
		curly: [ self stream basicPutAll: anObject reference ]; 
		curly: [ super visitInternalLink: anObject ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2006 11:58'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ self stream print: anObject reference ].	! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:21'!
visitListItem: anObject
	self stream tag: 'item'; space.
	super visitListItem: anObject.
	self stream cr.! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:21'!
visitOrderedList: anObject
	self stream environment: 'enumerate' do: [ super visitOrderedList: anObject ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:21'!
visitParagraph: anObject
	super visitParagraph: anObject.
	self stream cr; cr.! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/10/2006 13:05'!
visitPreformatted: anObject
	self stream environment: 'source' do: [
		anObject children do: [ :each |
			self stream basicPutAll: each text; cr ] ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/9/2006 13:25'!
visitTableRow: aTableRow
	self visitAll: aTableRow children separatedBy: [ self stream basicPut: $& ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/9/2006 13:25'!
visitTable: anObject
	self stream environment: 'tabular' do: [
		self stream curly: (String new: anObject columnCount withAll: $l); cr.
		self visitAll: anObject children separatedBy: [ self stream basicPutAll: '\\'; cr ] ].! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:25'!
visitText: anObject
	self stream nextPutAll: anObject text.! !

!PRLatexWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2006 13:22'!
visitUnorderedList: anObject
	self stream environment: 'itemize' do: [ super visitUnorderedList: anObject ].! !
PRLatexStream initialize!
